package list;

public class ListaLinkataSemplice
{
	Nodo head, tail;
	int cont;

	public ListaLinkataSemplice()
	{
		head = tail = null;
		cont = 0;
	}

	public boolean add(Object o)
	{
		Nodo tmp = new Nodo(o);

		if(cont == 0)
		{
			head = tail = tmp;
		}
		else
		{
			tail.next = tmp;
			tail = tail.next;

			//funziona, ma da' il mal di testa
			//tail = tail.next = tmp;
		}
		cont++;
		return true;
	}

	public boolean add(int index, Object o)
	{
		Nodo tmp = new Nodo(o);
		if(index > cont)
		{
			throw new java.util.NoSuchElementException("Ho solo " + cont + " elementi, non posso inserire in posizione " + index);
		}

		if(cont == 0 || index == cont)
		{
			return add(o);
		}

		System.out.println("Inserisco in posizione " + index);
		if(index == 0)
		{
			tmp.next = head;
			head = tmp;
		}
		else
		{
			Nodo cursore = head;
			for(int i=1;i<index;i++)
			{
				System.out.println("Avanzo di uno");
				cursore = cursore.next;
			}
			tmp.next = cursore.next;
			cursore.next = tmp;
			cont++;
		}
		return true;
	}

	public Object get(int index)
	{
		if(index >= cont || index < 0)
		{
			throw new java.util.NoSuchElementException("Ho " + cont + " elementi, la posizione " + index + " non e' accessibile");
		}

		Nodo cursore = head;
		while(index-- > 0)
		{
			cursore = cursore.next;
		}

		return cursore.val;
	}

	public Object remove(int index)
	{
		if(index >= cont || index < 0)
		{
			throw new java.util.NoSuchElementException("Ho " + cont + " elementi, la posizione " + index + " non e' accessibile");
		}

		Nodo cursore = head;

		if(index == 0)
		{
			Object retval = head.val;
			head = head.next;
			if(cont == 1)
			{
				tail = head;
			}
			cont--;
			return retval;
		}

		int i = index;

		while(--i > 0)
		{
			cursore = cursore.next;
		}

		Object retval = cursore.next.val;
		cursore.next = cursore.next.next;
		if(index == cont-1)
		{
			tail = cursore;
		}
		cont--;
		return retval;
	}

	public int size()
	{
		return cont;
	}

	public boolean isEmpty()
	{
		return (cont == 0);
	}

	public void clear()
	{
		head = tail = null;
		cont = 0;
	}

	public String toString()
	{
		String retval = "[";
		Nodo cursore = head;
		while(cursore != null)
		{
			retval = retval.concat(String.valueOf(cursore.val) + ", ");
			cursore = cursore.next;
		}
		retval = retval.concat("]");
		return retval;
	}
}
