package scaffali;

import java.util.*;
import java.io.*;

public class Libreria2
{
	Scaffale scaf;

	static final String nomeFileStato = "libreria.txt";

	public Libreria2(Scanner sc) throws InstantiationException
	{
		int numRip = 0;
		int larghezzaRip = 0;

		numRip = Integer.parseInt(sc.nextLine());
		larghezzaRip = Integer.parseInt(sc.nextLine());
		scaf = new Scaffale2(numRip, larghezzaRip);
		//e poi leggo il file di dati
		//...
		while(sc.hasNextLine())
		{
			Pubblicazione p = null;
			String tipo = sc.nextLine();
			if(tipo.equals("PubblicazioneAStampa"))
			{
				String titolo = sc.nextLine();
				int spessore = Integer.parseInt(sc.nextLine());
				String autore = sc.nextLine();
				String editore = sc.nextLine();
				int anno = Integer.parseInt(sc.nextLine());
				String isbn = sc.nextLine();
				p = new PubblicazioneAStampa(titolo, spessore, autore, editore, anno, isbn);
			}
			else if(tipo.equals("Audio"))
			{
				//lettura specifica per audio
				//istanziazione di oggetto audio
			}
			else if(tipo.equals("Video"))
			{
				//lettura specifica per video
				//istanziazione di oggetto video
			}
			else
			{
				System.err.println("Pubblicazione di tipo <" + tipo + "> non riconosciuta");
				continue;
			}

			CoordinatePubblicazione cp = scaf.inserisciPubblicazione(p);
			if(cp == null)
			{
				throw new InstantiationException("Una pubblicazione precedentemente presente non puo' piu' essere inserita");
			}

			System.out.println("Pubblicazione <" + p + "> inserita in posizione: " + cp);
		}
	}

	public Libreria2(int numRip, int larghezzaRip)
	{
		scaf = new Scaffale2(numRip, larghezzaRip);
	}

	public String toString()
	{
		return "Libreria2 con scaffale: " + scaf.toString();
	}

	public static void main(String[] argv) throws FileNotFoundException, InstantiationException
	{
		File f = new File(nomeFileStato);
		Libreria2 l = null;
		if(f.canRead())
		{
			Scanner sc = new Scanner(f);
			l = new Libreria2(sc);
		}
		else
		{
			try
			{
				l = new Libreria2(Integer.parseInt(argv[0]), Integer.parseInt(argv[1]));
			}
			catch(NumberFormatException nfe)
			{
				System.err.println("Usage: Libreria2 <numero ripiani> <larghezza ripiani>");
				System.exit(1);
			}
			catch(ArrayIndexOutOfBoundsException aioobe)
			{
				System.err.println("Usage: Libreria2 <numero ripiani> <larghezza ripiani>");
				System.exit(1);
			}
		}

		System.out.println(l);

		Scanner stdin = new Scanner(System.in);
		try
		{
			while(true)
			{
				System.out.print("Leggi Pubblicazione/Cerca/Cerca Per Tipo/Rimuovi/Leggi File/Stampa/Esci ? >");
				System.out.flush();
				String line = stdin.nextLine();
	
				if(line.equalsIgnoreCase("leggi pubblicazione"))
				{
					l.leggiPub(stdin);
				}
				else if(line.equalsIgnoreCase("Cerca Per Tipo"))
				{
					l.cercaPerTipo(stdin);
				}
				else if(line.equalsIgnoreCase("Cerca"))
				{
				}
				else if(line.equalsIgnoreCase("Rimuovi"))
				{
					l.rimuovi(stdin);
				}
				else if(line.equalsIgnoreCase("Leggi File"))
				{
				}
				else if(line.equalsIgnoreCase("Stampa"))
				{
					System.out.println(l.scaf);
				}
				else if(line.equalsIgnoreCase("Esci"))
				{
					break;
				}
			}
		}
		catch(NoSuchElementException nsee)
		{
		}
		finally
		{
			System.out.println("Salvataggio stato");
			//
			PrintWriter pw = new PrintWriter(f);
			l.scaf.serializzati(pw);
			pw.flush();
			pw.close();
		}
	}

	void leggiPub(Scanner stdin)
	{
		Pubblicazione p = null;

		System.out.print("Tipo pubblicazione ? > ");
		String tipo = stdin.nextLine();
		System.out.print("titolo ? > ");
		String titolo = stdin.nextLine();
		System.out.print("spessore ? > ");
		int spessore = Integer.parseInt(stdin.nextLine());
		if(tipo.equals("PubblicazioneAStampa"))
		{
			System.out.print("autore ? > ");
			String autore = stdin.nextLine();
			System.out.print("editore ? > ");
			String editore = stdin.nextLine();
			System.out.print("anno pubblicazione ? > ");
			int anno = Integer.parseInt(stdin.nextLine());
			System.out.print("isbn ? > ");
			String isbn = stdin.nextLine();
			p = new PubblicazioneAStampa(titolo, spessore, autore, editore, anno, isbn);
		}
		else if(tipo.equals("Audio"))
		{
			//lettura specifica per audio
			//istanziazione di oggetto audio
		}
		else if(tipo.equals("Video"))
		{
			//lettura specifica per video
			//istanziazione di oggetto video
		}
		else
		{
			System.err.println("Pubblicazione di tipo <" + tipo + "> non riconosciuta");
			return;
		}
		CoordinatePubblicazione cp = scaf.inserisciPubblicazione(p);
		if(cp != null)
		{
			System.out.println("Pubblicazione <" + p + "> inserita in " + cp);
		}
		else
		{
			System.out.println("Scaffale pieno");
		}
	}

	void rimuovi(Scanner stdin)
	{
		System.out.print("titolo ? > ");
		String titolo = stdin.nextLine();
		CoordinatePubblicazione cp = scaf.rimuoviPubblicazione(titolo);
		if(cp == null)
		{
			System.out.println("Pubblicazione < " + titolo + "> non presente");
		}
		else
		{
			System.out.println("Pubblicazione < " + titolo + "> rimossa da posizione " + cp);
		}
	}

	void cercaPerTipo(Scanner stdin)
	{
		System.out.print("Tipo di pubblicazione ? > ");
		String tipo = stdin.nextLine();
		Pubblicazione[] pubs = ((Scaffale2)scaf).cercaPerTipo(tipo);
		for(int i = 0;i<pubs.length;i++)
		{
			System.out.println(pubs[i]);
		}
	}
}
